<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class ReajusteRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getFaixaTabela($nrorg,$codigo){
        $sql = $this->entityManager->getConnection()->prepare("
        SELECT * 
          FROM FPA_FAIXATABELA
         WHERE NRORG = :P_NRORG
           AND NRTABELAFOLHA = :P_NRTABELAFOLHA
           AND DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                  FROM FPA_FAIXATABELA H1
                                 WHERE H1.NRORG = FPA_FAIXATABELA.NRORG
                                   AND H1.NRTABELAFOLHA = FPA_FAIXATABELA.NRTABELAFOLHA
                                   AND H1.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
        ");
        $sql->execute(
            array(
                "P_NRORG"=>$nrorg,
                "P_NRTABELAFOLHA"=>$codigo,
                "P_DTMESCOMPETENC"=>$this->hcmParameters->getDtCompetencia(),
            )   
        );
        return $sql->fetchAll();
    }

}

