<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class TpItemCCTService {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function novo($nmtipoitemcct)
    {
        $tipoitemcct = Repositories::GPE_TIPOITEMCCT;
        
        $novo = new $tipoitemcct;
        $novo->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $novo->setNmtipoitemcct($nmtipoitemcct);
        $novo->setIdativo('S');  
        $novo->setDtinclusao(DateUtil::getDataAtual()); 
        $novo->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $novo->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $novo->setDtultatu(DateUtil::getDataAtual());
        $novo->setCdoperultatu($this->hcmParameters->getCdoperador());
        $novo->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        
        $novo->setNrtipoitemcct(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'GPE_TIPOITEMCCT', 1, 12, true));
        
        $this->entityManager->persist($novo);
        $this->entityManager->flush();
        
        return $novo;
    }
    
} 