<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class CalendarioService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
       
    public function deleteCalendario($dataset) {
        $nrcalendario = $dataset["NRCALENDARIO"];
        $feriado = $this->entityManager->getRepository(Repositories::OCORCALENDARIO)->findBy(array("nrcalendario" => $nrcalendario, "nrorg" => $dataset['NRORG']));
        if (isset($feriado[0])) {
            throw new \Exception(Messages::HCM00000_GER_CALENDARIO_ALREADY_EXIST_FERIADO_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $calendario = $this->entityManager->getRepository(Repositories::CALENDARIO)->findOneBy(array("nrcalendario" => $nrcalendario, "nrorg" => $dataset['NRORG']));
            $this->entityManager->remove($calendario);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}